<?php

     // Roundcube-style variables
    $rcmail = rcmail::get_instance();

    $USERNAME = $rcmail->config->get('USERNAME');
    $HOME = $rcmail->config->get('HOME');
    $RUNAS_CMD = $rcmail->config->get('RUNAS_CMD');
    $MF = $rcmail->config->get('MF');
    $MTA = $rcmail->config->get('MTA');

?>

<h3>Vacation Message Setup</h3>

<?php

// Initialize variables
$oldForwardFileExist = FALSE;
$oldForwardFileConvert = FALSE;
$oldForwardFileResult = NULL;
$oldVacationMsg = NULL;
$oldForwardAddresses = NULL;
$oldFormatAddr_Arr = NULL;

$newForwardFileExist = FALSE;
$newForwardFileResult = NULL;
$newForwardMsg = NULL;
$newVacationMsg = NULL;
$newFormatVacation = NULL;
$newFormatAddr_Arr = NULL;

$newVacationFileExist = FALSE;
$newVacationFileResult = NULL;

$vacationExist = FALSE;
$localCopyExist = FALSE;
$vacationMsg = NULL;
$vacMsgLines = NULL;
$textbox = NULL;
$passHiddenInput = '';
$result = NULL;
$type = NULL;
$subject = NULL;
$subjects = '';

$dynamicFormContent = '';

if ($MTA === 'qmail') {
    // Do they have a .qmail file?
    if (have_file('.qmail', $result)) {
        $oldForwardFileExist = TRUE;
        $oldForwardFileResult = $result;
        $type = 'q';
    }
}
else if ($MTA === 'postfix') {
    // Do they have a .forward file?
    if (have_file('.forward', $result)) {
        $oldForwardFileExist = TRUE;
        $oldForwardFileResult = $result;
        $type = 'f';
    }
}
    
// Do they have a mailfilter-vacation file?
if (have_file('Maildir/mailfilter-vacation', $result)) {
    $newVacationFileExist = TRUE;
    $newVacationMsg = '<strong>You have an old supported vacation file</strong><br>';
    $newVacationFileResult = $result;
    foreach ($newVacationFileResult as $line) {
        if (is_newFormatVacation($line, $subject)) {
            continue;
        }
    }
    $passHiddenInput .= '<input type="hidden" name="newVacationFileExist" value="1">';
}

//Do they have a mailfilter-forward file?
if (have_file('Maildir/mailfilter-forward', $result)) {
    $newForwardFileExist = TRUE;
    $newForwardMsg = '<strong>You currently have a supported vacation/forward file.</strong><br><br>';
    $newForwardFileResult = $result;
    foreach ($newForwardFileResult as $line) {
        if (is_newFormatLocalCopy($line)) {
            $passHiddenInput .= '<input type="hidden" name="localCopy" value="1">';
        }
        if (is_newFormatAddress($line, $newFormatAddr_Arr)) {
            continue;
        }
        if (is_newFormatVacation($line, $subject)) {
            continue;
        }
    } 
    $passHiddenInput .= '<input type="hidden" name="newForwardFileExist" value="1">';
}

// Show the subject box
if (empty($subject)) {
    $subject = 'Away on vacation';
}

// Is the old forward file one we recognize (no weird procmail stuff, etc)
if ($oldForwardFileExist) {
    $oldForwardFileConvert = TRUE;
    $oldVacationMsg = '<strong>You have a vacation file that is no longer being supported!</strong><br><br>';
    switch ($type) {
        case 'q':
            $firstLine = TRUE;
            foreach ($oldForwardFileResult as $line) {
                if ($firstLine) {
                    $firstLine = FALSE;
                    if (preg_match("/^\s*$/", $line)) {
                        $oldForwardFileConvert = FALSE;
                        break;
                    }
                }
                if (is_blankline($line) || is_comment($line)) {
                    continue;
                }
                if (is_oldFormatVacation($line)) {
                    $vacationExist = TRUE;
                    continue;
                }
                if (is_oldFormatLocalCopy($line)) {
                    $localCopyExist = TRUE;
                    $passHiddenInput .= '<input type="hidden" name="localCopy" value="1">';
                    continue;
                }
                // Found something bizarre lets let the user know
                if (!is_oldFormatAddress($line, $oldFormatAddr_Arr)) {
                    $oldForwardFileConvert = FALSE;
                    break;
                }
            }
            break;
        case 'f':
        foreach ($oldForwardFileResult as $line) {
            if (is_blankline($line) || is_comment_forward($line)) {
                continue;
            }
            if (is_oldFormatVacation($line)) {
                $vacationExist = TRUE;
                continue;
            }
            if (is_oldFormatLocalCopy($line)) {
                $localCopyExist = TRUE;
                $passHiddenInput .= '<input type="hidden" name="localCopy" value="1">';
                continue;
            }
            // Found something bizarre, let's let the user know
            if (!is_oldFormatAddress_forward($line, $oldFormatAddr_Arr)) {
                $oldForwardFileConvert = FALSE;
                break;
            }
        }
        break;
   }
}

// Are we converting?
if ($oldForwardFileConvert) {
    $oldVacationMsg .= '<strong>Submitting this form will convert the old format to the new supported format!</strong><br>';
    // Let the user know where their mail is stored,forwarded, and/or vacationed
    if ($vacationExist) {
        $oldVacationMsg .= 'You have vacation enabled, if you would like to migrate it complete the form below!<br>';
    }
    if (is_array($oldFormatAddr_Arr)) {
        if ($localCopyExist) {
            $oldVacationMsg .= 'In this file, you are forwarding your mail to the addresses below and keeping a local copy! 
                                These will be migrated, however if you would like to edit them, check out the forward webtool!<br>';
        }
        else {
            $oldVacationMsg .= 'In this file, you are forwarding your mail to the addresses below! 
                                These will be migrated, however if you would like to edit them, check out the forward webtool!<br>';
        }
        $oldFormatAddr_S = base64_encode(serialize($oldFormatAddr_Arr));
        $passHiddenInput .= '<input type="hidden" name="oldFormatAddr_S" value="'.$oldFormatAddr_S.'">';
        $oldForwardAddresses = '<ul>';
        foreach ($oldFormatAddr_Arr as $address) {
            $oldForwardAddresses .= "<li>$address</li>";
        }
        $oldForwardAddresses .= '</ul>';
    }
    $passHiddenInput .= '<input type="hidden" name="forwardType" value="'.$type.'">';
}
elseif ($oldForwardFileExist) {
    $oldVacationMsg .= '<strong>However, we cannot convert the file to the new supported file format since it seems your file 
                        has some extra goodies we can\'t understand! Submitting the form below will add and enable vacation 
                        functionality to a file in the new supported format!</strong><br>';
}

// Pass forward addresses from newForward file as hidden input 
if(isset($newFormatAddr_Arr)){
    $newFormatAddr_S = base64_encode(serialize($newFormatAddr_Arr));
    $passHiddenInput .= '<input type="hidden" name="newFormatAddr_S" value="'.$newFormatAddr_S.'">';
}

if ($newForwardFileExist || $oldForwardFileExist || $newVacationFileExist) {
    $dynamicFormContent .= $oldVacationMsg . $oldForwardAddresses . $newVacationMsg . $newForwardMsg;
}
else {
    $dynamicFormContent .= '<strong>You currently have no vacation/forward file.</strong><br><br>';
}

$textbox = array('Away on vacation', 'Not available', 'Out of town', 'Will return next week', 'Auto Reply', 'New Address', 'I have moved', 'I have graduated', 'Out of the Office');
for($i = 0; $i < count($textbox); $i++) {
    $selected = ($textbox[$i] == $subject) ? 'selected="selected"' : '';
    $subjects .= "<option value=\"$textbox[$i]\" $selected>$textbox[$i]</option>";
}

if(have_file('.vacation.msg', $result)) {
    $vacationMsg = 'You have the option to keep the message you already have (provided below) or edit it.';
    $vacMsgLines = implode("\r\n", $result);
    $vacMsgLines = rtrim($vacMsgLines);
}
else {
    $vacationMsg = 'You have the option to keep the default message (provided below) or edit it.<br><br>';
    $vacMsgLines = "I will not be reading my mail for a while.\r\nYour mail will be read when I return.";
}

?>

<form id="webtools-form" onsubmit="return false;">
    <fieldset style="padding:10px" class="ui-widget ui-widget-content ui-corner-all">
        <div id="dynamic_content">
            <?=$dynamicFormContent?>
        </div>
        Please select the subject of the autoreplied vacation message!
        <br><br>
        <label style="display:block; float:left; margin-right:0.5em;">Subject:</label>
        <select name="subject" class="webtools-select"><?=$subjects?></select>
        <br>
        <div id="vacation_msg">
            <?=$vacationMsg?>
        </div>
        <br>
        <textarea name="message" cols="70" rows="20"><?=$vacMsgLines?></textarea>
        <br><br>
        <button class="webtools-button ui-state-default ui-corner-all" onclick="return vacation_post();">Submit</button>
        <button class="webtools-button ui-state-default ui-corner-all" type="reset">Reset</button>
    </fieldset>
</form>


<!--?php
}
elseif ($_POST['page'] === 'disable') {

    $newForwardFileExist = FALSE;
    $newVacationLineExist = FALSE;

    $oldForwardFileExist = FALSE;
    $oldForwardFileConvert = FALSE;
    $oldVacationFileExist = FALSE;
    $oldVacationLineExist = FALSE;
    $oldLocalCopyLineExist = FALSE;
    $localCopyLineExist = FALSE;
    
    $success = TRUE;

    $result = NULL;
    $insert = NULL;
    $msg = NULL;
    $user_cmds = NULL;

    $oldFormatAddr_Arr = NULL;
    $newFormatAddr_Arr = NULL;

    /* Did the sys admin forget to set the MTA for forwardvacation webtools? */
    if (!isset($MTA) || empty($MTA)) {
        handle_error(9);
    }

    /* Which MTA are we using so we know which old forward file to look for */
    if ($MTA === 'qmail') {
        // Do they have a .qmail file?
        if (have_file('.qmail', $result)) {
            $oldForwardFileConvert = TRUE;
            $firstLine = TRUE;
            foreach ($result as $line) {
                if ($firstLine) {
                    $firstLine = FALSE;
                    if (preg_match("/^\s*$/", $line) ) {
                        $oldForwardFileConvert = FALSE;
                        break;
                    }
                }
                if (is_blankline($line) || is_comment($line)) {
                    continue;
                }
                if (is_oldFormatVacation($line)) {
                    $oldVacationLineExist = TRUE;
                    continue;
                }
                if (is_oldFormatLocalCopy($line)) {
                    $localCopyLineExist = TRUE;
                    continue;
                }
                // Found something bizarre lets let the user know
                if (!is_oldFormatAddress($line, $oldFormatAddr_Arr)){
                    $oldForwardFileConvert = FALSE;
                    break;
                }
            }
            $user_cmds['qmail'] = "find $HOME -maxdepth 1 -name .qmail -exec mv '{}' $HOME/.qmail-old-webtool \;";
        }
    }
    else if ($MTA === 'postfix') {
        // Do they have a .forward file?
        if (have_file('.forward', $result)) {
            $oldForwardFileExist = TRUE;
            $oldForwardFileConvert = TRUE;
            foreach ($result as $line) {
                if (is_blankline($line) || is_comment_forward($line)) {
                    continue;
                }
                if (is_oldFormatVacation($line)) {
                    $oldVacationLineExist = TRUE;
                    continue;
                }
                if (is_oldFormatLocalCopy($line)) {
                    $localCopyLineExist = TRUE;
                    continue;
                }
                // Found something bizarre, let's let the user know
                if (!is_oldFormatAddress_forward($line, $oldFormatAddr_Arr)) {
                    $oldForwardFileConvert = FALSE;
                    break;
                }
            }
            $user_cmds['forward'] = "find $HOME -maxdepth 1 -name .forward -exec mv '{}' $HOME/.forward-old-webtool \;";
        }
    }   
    else {
        // Some unknown MTA to webtools
        handle_error(10);
    }

    // Set insert to display some rutgers specific comments
    $insert = "################################################\n";
    $insert .= "# THIS FILE WAS CREATED BY A WEBTOOL.          #\n";
    $insert .= "# DO NOT EDIT THIS FILE BY HAND.               #\n";
    $insert .= "################################################\n\n";

    /* Does the user have the not so old vacation file, if so remove it */
    if (have_file('Maildir/mailfilter-vacation', $result)) {
        $oldVacationFileExist = TRUE;
        $user_cmd = "find $HOME -maxdepth 2 -path $HOME/Maildir/mailfilter-vacation -exec rm -f '{}' \;";
        $exec_target = "$RUNAS_CMD $USER $user_cmd";
        exec($exec_target, $result, $status);
        if ($status != 0) {
            $msg .= 'Tried removing your old vacation file, but failed.<br>';
            $success = FALSE;
        }
        else {
            $msg .= 'Removed your old vacation file.<br>';
        }
    }

    /* Does the user have the new "preferred" forward-vacation file */
    if (have_file('Maildir/mailfilter-forward', $result)) {
        $localCopyLineExist = TRUE;
        $newForwardFileExist = TRUE;
        foreach ($result as $line) {
            if (is_newFormatLocalCopy($line)) {
                $localCopyLineExist = FALSE;
            }
            if (is_newFormatVacation($line,$_)) {
                $newVacationLineExist = TRUE;
                continue;
            }
            if (is_newFormatAddress($line, $newFormatAddr_Arr)) {
                continue;
            }
        }
    }

    /* Let the user know what's going on since they have an old forward file */
    if ($oldForwardFileConvert) {
        if(is_array($oldFormatAddr_Arr)) {
            $msg .= 'Old forwarding addresses exist:<br>';
            foreach ($oldFormatAddr_Arr as $address) {
                $msg .= $address.'<br>';
            }
            $msg .= 'These addresses were converted to the new formatted forward file<br>';
        }
    }

    /* What should the new forward file contain? */
    if ($newForwardFileExist || $oldForwardFileExist) {
        // Any contents left to put back in the mailfilter file?
        if (is_array($newFormatAddr_Arr) || is_array($oldFormatAddr_Arr)) {
            if (is_array($newFormatAddr_Arr) && is_array($oldFormatAddr_Arr)) {
                $new_Arr = array_merge($newFormatAddr_Arr,$oldFormatAddr_Arr);
            }
            else if (is_array($newFormatAddr_Arr) && !is_array($oldFormatAddr_Arr)) {
                $new_Arr = $newFormatAddr_Arr;
            }
            else if (!is_array($newFormatAddr_Arr) && is_array($oldFormatAddr_Arr)) {
                $new_Arr = $oldFormatAddr_Arr;
            }
            if ($localCopyLineExist) {
                $addresses = implode(' ', $new_Arr);
                $insert .= "cc \"!$addresses\"";
            }
            else {
                $addresses = implode(' ', $new_Arr);
                $insert .= "to \"!$addresses\"";
            }
            // Write the new forward file w/out vacation.
            $user_cmd = "$MF Maildir/mailfilter-forward";
            $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
            unipipe_exec($exec_target, $insert);
        }
        else {
            // Let's remove the mailfilter file since only vacation was in it.
            $user_cmd = "find $HOME -maxdepth 2 -path $HOME/Maildir/mailfilter-forward -exec rm -f '{}' \;";
            $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
            exec($exec_target, $result, $status);
            if ($status != 0) {
                $msg .= 'Tried removing your vacation file, but failed.<br>';
                $success = FALSE;
            }
            else {
                $msg .= 'Removed your vacation file.<br>';
            }
        }
    }

    // Move the old .qmail or .forward file
    if (isset($user_cmds)) {
        foreach($user_cmds as $oldFile => $user_cmd) {
            $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
            exec($exec_target, $result, $status);
            if ($status != 0) {
                $msg .= "Could not move your .$oldFile file to .$oldFile-old-webtool<br>";
                $success = FALSE;
            }
            else {
                $msg .= "Moved your .$oldFile file to .$oldFile-old-webtool!<br>";
            }
        }
    }

    if (!($newVacationLineExist || $oldVacationFileExist || $oldVacationLineExist)) {
        $msg .= 'Vacation has not been disabled, since it appears you never had it enabled!<br>';
        $success = FALSE;
    }
    else {
        $msg .= 'Vacation has been disabled!<br>';
    }

    echo '<center>';
    if($success){
        echo "<h4>Thank you $USERNAME,</h4>" , $msg;
    }
    else {
        echo "<h4>Sorry $USERNAME,</h4>" , $msg;
    }
    echo '</center>';

}
elseif ($_POST['page'] === 'commit') {
    
    /* Get the POST variables from $_POST array */

    // Always use these
    $subject = $_POST['subject'];
    $message = $_POST['message'];
    
    if (isset($message)) {
        $message = stripslashes($message);
    }

    // Old format forward file vars
    $forwardType = $_POST['forwardType'];
    $oldFormatAddr_S = $_POST['oldFormatAddr_S'];
    $localCopy = $_POST['localCopy'];

    // New format forward file vars
    $newFormatAddr_S = $_POST['newFormatAddr_S'];
    $newForwardFileExist = $_POST['newForwardFileExist'];
    $newVacationFileExist = $_POST['newVacationFileExist'];

    /* Initialize new variables for this page */
    $createForward = TRUE;
    $success = TRUE;
    $allAddr_Arr = array();
    $newFormatAddr_Arr = NULL;
    $insert = NULL;
    $msg = NULL;
    $type = NULL;

    // Set insert to display some rutgers specific comments
    $insert = "################################################\n";
    $insert .= "# THIS FILE WAS CREATED BY A WEBTOOL.          #\n";
    $insert .= "# DO NOT EDIT THIS FILE BY HAND.               #\n";
    $insert .= "################################################\n\n";

    if(empty($subject)) {
        $subject = "Away on vacation";
    }

    // Append the vacation mailfilter rule to be inserted
    $insert .= getVacationRule($subject, NULL)."\n";

    // Are we converting from old formatted forward file?
    if(isset($forwardType)) {
            myecho('Converting from old format..');
        if(isset($oldFormatAddr_S)) {
            myecho('Moving some addresses over..');
            $oldFormatAddr_Arr = unserialize(base64_decode($oldFormatAddr_S));
            $allAddr_Arr = array_merge($oldFormatAddr_Arr, $allAddr_Arr);
        }
    }

    // Are we adding on top of new formatted forward file?
    if (isset($newFormatAddr_S)) {
        $newFormatAddr_Arr = unserialize(base64_decode($newFormatAddr_S));
        $allAddr_Arr = array_merge($newFormatAddr_Arr, $allAddr_Arr);
    }

    // Are we leaving a local copy?
    if (isset($localCopy) && ($localCopy == 0)) {
        if (is_array($allAddr_Arr)) {
            $addresses = implode(" ", $allAddr_Arr);
            $insert .= 'to "!'.$addresses.'"';
        }
    }
    else {
        if (is_array($allAddr_Arr)) {
            $addresses = implode(' ', $allAddr_Arr);
            $insert .= 'cc "!'.$addresses.'"';
        }
    }
    myecho("$insert");

    // Should we write the new forward file
    if ($createForward) {
        $user_cmd = "$MF Maildir/mailfilter-forward";
        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
        unipipe_exec($exec_target, $insert);
        $msg .= 'Your new vacation file was created.<br>';
    }
    
    // Write the vacation message file
    $user_cmd = "$MF .vacation.msg";
    $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
    unipipe_exec($exec_target, $message);

    // Remove the old vacation file if it exists
    if(isset($newVacationFileExist)) {
        $user_cmd = "find $HOME -maxdepth 2 -path $HOME/Maildir/mailfilter-vacation -exec mv '{}' $HOME/Maildir/mailfilter-vacation-old \;";
        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
        exec($exec_target, $result, $status);
        if ($status != 0) {
            $msg .= 'Could not move your old mailfilter-vacation file to mailfilter-vacation-old<br>';
            $success = FALSE;
        }
        else {
            $msg .= 'Moved your old mailfilter-vacation file to mailfilter-vacation-old<br>';
        }
    }

    // Remove the old forward file if it exists
    if (isset($forwardType) && !empty($forwardType)) {
        switch($forwardType) {
            case 'f':
                $user_cmd = "find $HOME -maxdepth 1 -name .forward -exec mv '{}' $HOME/.forward-old-webtool \;";
                $type = '.forward';
                break;
            case 'q':
                $user_cmd = "find $HOME -maxdepth 1 -name .qmail -exec mv '{}' $HOME/.qmail-old-webtool \;";
                $type = '.qmail';
            break;
        }
        
        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
        exec($exec_target, $result, $status);
        
        if ($status != 0) {
            $msg .= "Could not move your old $type file to $type-old-webtool.<br>";
            $success = FALSE;
        }
        else {
            $msg .= "Your old $type file has been moved to $type-old-webtool.";
        }
    }

    // Remove the autoresponse stuff whenever the user makes it this far
    $file_Arr[0] = 'autoresponsedb.gdbm';
    $file_Arr[1] = 'autoresponsedb.lock';
    foreach($file_Arr as $file) {
        $user_cmd = "find $HOME -maxdepth 1 -name $file -exec rm -f '{}' \;";
        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
        exec($exec_target, $result, $status);
    }
    
    echo '<center>';
    if($success) {
        echo "<h4>Thank you $USERNAME,</h4>" , $msg;
    }
    else {
        echo "<h4>Sorry $USERNAME,</h4>" , $msg;
    }
    echo '</center>';

}
?-->
